package pucrs.hslcommunicationservice.aws;

import com.amazonaws.auth.AWSStaticCredentialsProvider;
import com.amazonaws.services.simpleemail.AmazonSimpleEmailService;
import com.amazonaws.services.simpleemail.AmazonSimpleEmailServiceClientBuilder;
import com.amazonaws.services.simpleemail.model.*;
import org.springframework.stereotype.Component;

@Component
public class SESClient extends Credentials {

    private final AmazonSimpleEmailService sesClient;
    private final String BASE_EMAIL = "josea_vgf@hotmail.com";

    public SESClient() {
        this.sesClient = AmazonSimpleEmailServiceClientBuilder.standard()
                .withRegion("us-east-2")
                .withCredentials(new AWSStaticCredentialsProvider(setup()))
                .build();
    }

    public void sendEmail(String destiny, String subject, String content) {
        SendEmailRequest request = new SendEmailRequest()
                .withDestination(new Destination().withToAddresses(destiny))
                .withMessage(new Message()
                        .withBody(new Body().withText(new Content().withCharset("UTF-8").withData(content)))
                        .withSubject(new Content().withCharset("UTF-8").withData(subject))
                )
                .withSource(BASE_EMAIL);
        sesClient.sendEmail(request);
        System.out.println("Email sent!");
    }
}
