package pucrs.hslcommunicationservice.aws;

import com.amazonaws.auth.AWSStaticCredentialsProvider;
import com.amazonaws.services.sns.AmazonSNS;
import com.amazonaws.services.sns.AmazonSNSClientBuilder;
import com.amazonaws.services.sns.model.CreateTopicResult;
import com.amazonaws.services.sns.model.PublishResult;
import org.springframework.stereotype.Component;


@Component
public class SNSClient extends Credentials {

    private AmazonSNS snsClient;

    private final String topicName = "comunicahsl";
    private String topicArn;

    public SNSClient() {
        this.snsClient = AmazonSNSClientBuilder.standard()
                .withRegion("us-east-1")
                .withCredentials(new AWSStaticCredentialsProvider(setup()))
                .build();
        this.loadTopic();
    }

    private void loadTopic() {
        CreateTopicResult result = this.snsClient.createTopic(topicName);
        topicArn = result.getTopicArn();
    }

    public PublishResult publish(String message) {
        return snsClient.publish(topicArn, message);
    }

    public PublishResult publish(String message, String subject) {
        return snsClient.publish(topicArn, message, subject);
    }
}
