package pucrs.hslcommunicationservice.configuration.security;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.AuthenticationProvider;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.stereotype.Component;
import pucrs.hslcommunicationservice.repository.UserRepository;

import java.util.ArrayList;

@Component
public class CustomAuthenticationProvider implements AuthenticationProvider {

    @Autowired
    private UserRepository userRepository;

    @Override
    public Authentication authenticate(Authentication authentication) throws AuthenticationException {
        String registry = authentication.getName();

        boolean shouldLogin = userRepository.findById(Long.parseLong(registry)).isPresent();

        if(shouldLogin){
            return new UsernamePasswordAuthenticationToken(
                    registry, "", new ArrayList<>());
        } else throw new RuntimeException("Usuário não encontrado no sistema!");
    }

    @Override
    public boolean supports(Class<?> authentication) {
        return authentication.equals(UsernamePasswordAuthenticationToken.class);
    }
}
