package pucrs.hslcommunicationservice.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import pucrs.hslcommunicationservice.domain.Announcement;
import pucrs.hslcommunicationservice.service.AnnouncementService;

import java.util.List;

@RestController
@RequestMapping("/announcement")
public class AnnouncementController {

    @Autowired
    private AnnouncementService announcementService;

    @PostMapping
    public Announcement postAnnouncement(
            @RequestBody Announcement announcement
    ) {
        return announcementService.addAnnouncement(announcement);
    }

    @GetMapping
    public List<Announcement> getAnnouncements(
            @RequestParam(required = false) Long idDepartment,
            @RequestParam(required = false) Integer page,
            @RequestParam(required = false) Integer pageSize,
            @RequestHeader String Authorization


    ) {
       return announcementService.getAnnouncements(page, pageSize, idDepartment);
    }

    @GetMapping("/{id}")
    public Announcement getAnnouncement(
            @PathVariable Long id,
            @RequestHeader String Authorization
    ) {
        return announcementService.getAnnouncementById(id, Authorization);
    }

    @PutMapping
    public Announcement putAnnouncement(
            @RequestBody Announcement announcement
    ) {
        return announcementService.editAnnouncement(announcement);
    }

    @DeleteMapping("/{id}")
    public boolean deleteAnnouncement(
            @PathVariable Long id
    ) {
        return announcementService.deleteAnnnouncementById(id);
    }

}