package pucrs.hslcommunicationservice.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import pucrs.hslcommunicationservice.domain.Department;
import pucrs.hslcommunicationservice.service.DepartmentService;

import java.util.List;

@RestController
@RequestMapping("/department")
public class DepartmentController {

    @Autowired
    private DepartmentService departmentService;

    @PostMapping
    public Department postDepartment(
            @RequestBody Department department
    ) {
        return departmentService.addDepartment(department);
    }

    @GetMapping("/{id}")
    public Department getDepartment(
            @PathVariable Long id
    ) {
        return departmentService.getDepartmentById(id);
    }

    @GetMapping
    public List<Department> getDepartments() {
        return departmentService.getDepartments();
    }
}
