package pucrs.hslcommunicationservice.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import pucrs.hslcommunicationservice.domain.User;
import pucrs.hslcommunicationservice.service.UserService;

import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/user")
public class UserController {

    @Autowired
    private UserService userService;

    @PostMapping
    public User postUser(
            @RequestBody User user
    ) {
        return userService.addUser(user);
    }

    @GetMapping
    public List<User> getUsers() {
        return userService.getUsers();
    }

    @GetMapping("/{registry}")
    public User getUsers(
            @PathVariable Long registry
    ) {
        return userService.getUserByRegistry(registry);
    }

    @DeleteMapping("/{registry}")
    public Boolean deleteUsers(
            @PathVariable Long registry
    ) {
        return userService.deleteUser(registry);
    }

    @PostMapping("/import")
    public List<User> importUsers(
            @RequestParam String csvFromS3
    ) throws IOException {
        return userService.importUsers(csvFromS3);
    }

    @GetMapping("/birthdays")
    public List<User> getBirthdayUsers(
            @RequestParam int month
    ) {
        return userService.getBirthdayUsers(month);
    }


}