package pucrs.hslcommunicationservice.domain;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;

@Entity
@Table(name = "users_announcements_view")
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class UserAnnouncementView {

    @Id
    @Column(nullable = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @ManyToOne(cascade = CascadeType.MERGE, fetch = FetchType.EAGER)
    @JoinColumn(name = "idUser", referencedColumnName = "registry")
    private User user;

    @ManyToOne(cascade = CascadeType.REFRESH, fetch = FetchType.EAGER)
    @JoinColumn(name = "idAnnouncement", referencedColumnName = "id")
    private Announcement announcement;

    @Column
    private boolean viewed;
}
